%define major 0
%define libname %mklibname nfsidmap %{major}
%define devname %mklibname nfsidmap -d

Name:       nfs-utils
Epoch:      1
Version:    2.5.2
Release:    %mkrel 2
Summary:    The utilities for Linux NFS server
Group:      Networking/Other
License:    GPL
URL:        http://linux-nfs.org/
Source0:    https://www.kernel.org/pub/linux/utils/nfs-utils/%{version}/%{name}-%{version}.tar.xz
Source1:    id_resolver.conf
Source2:    lockd.conf
Source3:    24-nfs-server.conf
Source4:    nfsconvert.py
Source5:    nfsconvert.sh
Source6:    nfs-convert.service
Patch100:   nfs-utils-1.2.1-statdpath-man.patch
Patch101:   nfs-utils-1.2.1-exp-subtree-warn-off.patch
Patch102:   nfs-utils-1.2.5-idmap-errmsg.patch
Patch103:   nfs-utils-2.3.1-systemd-gssproxy-restart.patch
Patch104:   nfs-utils-2.3.3-man-tcpwrappers.patch
Patch105:   nfs-utils-2.3.3-nfsconf-usegssproxy.patch
Patch106:   nfs-utils-2.4.2-systemd-svcgssd.patch

Requires(pre): rpm-helper
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(postun): rpm-helper
Requires:       rpcbind
Requires:       keyutils
Requires:       gssproxy
Recommends:     quota-rpc
BuildRequires:  tcp_wrappers-devel
BuildRequires:  keyutils-devel
BuildRequires:  pkgconfig(krb5) >= 1.3
BuildRequires:  pkgconfig(librpcsecgss) >= 0.12
BuildRequires:  pkgconfig(libtirpc)
BuildRequires:  pkgconfig(blkid)
BuildRequires:  pkgconfig(libcap)
BuildRequires:  pkgconfig(libevent)
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  pkgconfig(devmapper)
BuildRequires:  pkgconfig(sqlite3)
BuildRequires:  pkgconfig(mount)
BuildRequires:  pkgconfig(python3)
BuildRequires:  rpcgen
Obsoletes:      nfs-utils-clients
Provides:       nfs-utils-clients

%description
This package provides various programs needed for NFS support on server.

%package -n %{libname}
Summary:        NFSv4 User and Group ID Mapping Library
License:        BSD
BuildRequires:  openldap-devel
Requires:       openldap

%description -n %{libname}
Library that handles mapping between names and ids for NFSv4.

%package -n %{devname}
Summary:    Development files for the libnfsidmap library
Requires:	%{libname} = %{epoch}:%{version}-%{release}

%description -n %{devname}
This package includes header files and libraries necessary for
developing programs which use the libnfsidmap library.

%prep
%setup -q
%autopatch -p1
find . -name "*.orig" | xargs rm -f

%build
%serverbuild
sh -x autogen.sh
%define _statdpath %{_sharedstatedir}/nfs/statd 
%configure \
    CFLAGS="%{optflags} -D_FILE_OFFSET_BITS=64" \
    LDFLAGS="%{ldflags}" \
    --enable-mountconfig \
    --enable-ipv6 \
    --with-statdpath=%{_statdpath} \
    --enable-libmount-mount \
    --with-systemd \
    --without-tcp-wrappers \
    --with-pluginpath=%{_libdir}/libnfsidmap \
    --enable-junction

%make_build all

%install
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_prefix}/lib/systemd/system
install -d %{buildroot}%{_prefix}/lib/systemd/system-generators
install -d %{buildroot}%{_mandir}/{man5,man8}

%make_install

install -s -m 755 tools/rpcdebug/rpcdebug %{buildroot}%{_sbindir}

install -d %{buildroot}%{_sysconfdir}
install -m 644 utils/mount/nfsmount.conf %{buildroot}%{_sysconfdir}
install -m 644 nfs.conf %{buildroot}%{_sysconfdir}
install -m 644 support/nfsidmap/idmapd.conf %{buildroot}%{_sysconfdir}

install -d %{buildroot}%{_sysconfdir}/request-key.d
install -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/request-key.d

install -d %{buildroot}%{_sysconfdir}/modprobe.d
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/modprobe.d/lockd.conf

install -d %{buildroot}%{_sysconfdir}/gssproxy
install -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/gssproxy

install -m 755 %{SOURCE4} %{buildroot}%{_sbindir}/nfsconvert

install -d %{buildroot}%{_libexecdir}/nfs-utils
install -m 755 %{SOURCE5} %{buildroot}%{_libexecdir}/nfs-utils/nfsconvert.sh

install -m 644 %{SOURCE6} %{buildroot}%{_unitdir}/nfs-convert.service

rm -rf %{buildroot}%{_libdir}/*.{a,la}
rm -rf %{buildroot}%{_libdir}/libnfsidmap/*.{a,la}

touch %{buildroot}%{_sharedstatedir}/nfs/rmtab
mv %{buildroot}%{_sbindir}/rpc.statd %{buildroot}/sbin

install -d %{buildroot}%{_sharedstatedir}/nfs/rpc_pipefs
install -d %{buildroot}%{_sharedstatedir}/nfs/statd/sm
install -d %{buildroot}%{_sharedstatedir}/nfs/statd/sm.bak
install -d %{buildroot}%{_sharedstatedir}/nfs/v4recovery

install -d %{buildroot}%{_sysconfdir}/exports.d

cat >%{buildroot}%{_sysconfdir}/exports <<EOF
# /etc/exports: the access control list for filesystems which may be exported
#               to NFS clients.  See exports(5).
EOF

chmod 4755 %{buildroot}/sbin/mount.nfs

pathfix.py -pni "%{__python3} %{py3_shbang_opts}" %{buildroot}%{_sbindir}/nfsiostat
pathfix.py -pni "%{__python3} %{py3_shbang_opts}" %{buildroot}%{_sbindir}/mountstats

%pre
%_pre_useradd rpcuser %{_localstatedir}/lib/nfs /bin/false

%post
%_post_unit nfs-client.target

%preun
%_preun_unit nfs-client.target nfs-server.service nfs-blkmap.service nfs-secure.service nfs-secure-server.service

%postun
%_postun_userdel rpcuser

%files
%doc README NEWS COPYING
%dir %{_localstatedir}/lib/nfs
%dir %{_localstatedir}/lib/nfs/v4recovery
%dir %{_localstatedir}/lib/nfs/rpc_pipefs
%dir %{_libexecdir}/nfs-utils
%dir %attr(700,rpcuser,rpcuser) %{_localstatedir}/lib/nfs/statd
%dir %attr(700,rpcuser,rpcuser) %{_localstatedir}/lib/nfs/statd/sm
%dir %attr(700,rpcuser,rpcuser) %{_localstatedir}/lib/nfs/statd/sm.bak
%ghost %attr(644,rpcuser,rpcuser) %{_localstatedir}/lib/nfs/statd/state
%dir %{_sysconfdir}/exports.d
%config(noreplace) %{_localstatedir}/lib/nfs/etab
%config(noreplace) %{_localstatedir}/lib/nfs/rmtab
%config(noreplace) %{_sysconfdir}/exports
%config(noreplace) %{_sysconfdir}/nfsmount.conf
%config(noreplace) %{_sysconfdir}/nfs.conf
%config(noreplace) %{_sysconfdir}/request-key.d/id_resolver.conf
%config(noreplace) %{_sysconfdir}/modprobe.d/lockd.conf
%config(noreplace) %{_sysconfdir}/gssproxy/24-nfs-server.conf
%{_unitdir}/*
%{_prefix}/lib/systemd/system-generators/*
%{_libexecdir}/nfs-utils/nfsconvert.sh
%{_sbindir}/exportfs
%{_sbindir}/nfsstat
%{_sbindir}/rpcdebug
%{_sbindir}/rpc.mountd
%{_sbindir}/rpc.nfsd
%{_sbindir}/showmount
%{_sbindir}/rpc.idmapd
%{_sbindir}/rpc.gssd
%{_sbindir}/sm-notify
%{_sbindir}/start-statd
%{_sbindir}/mountstats
%{_sbindir}/nfsiostat
%{_sbindir}/nfsidmap
%{_sbindir}/blkmapd
%{_sbindir}/nfsconf
%{_sbindir}/nfsref
%{_sbindir}/nfsconvert
%{_sbindir}/nfsdcld
%{_sbindir}/nfsdclddb
%{_sbindir}/nfsdclnts
%attr(4755,root,root) /sbin/mount.nfs
/sbin/rpc.statd
/sbin/nfsdcltrack
/sbin/mount.nfs4
/sbin/umount.nfs
/sbin/umount.nfs4
%{_mandir}/man5/exports.5*
%{_mandir}/man5/nfs.5*
%{_mandir}/man5/nfs.conf.5*
%{_mandir}/man5/nfsmount.conf.5*
%{_mandir}/man7/nfsd.7*
%{_mandir}/man7/nfs.systemd.7*
%{_mandir}/man8/exportfs.8*
%{_mandir}/man8/mountd.8*
%{_mandir}/man8/nfsd.8*
%{_mandir}/man8/rpc.mountd.8*
%{_mandir}/man8/rpc.nfsd.8*
%{_mandir}/man8/mount.nfs.8*
%{_mandir}/man8/nfsconf.8*
%{_mandir}/man8/nfsref.8*
%{_mandir}/man8/rpc.sm-notify.8*
%{_mandir}/man8/sm-notify.8*
%{_mandir}/man8/umount.nfs.8*
%{_mandir}/man8/rpc.statd.8*
%{_mandir}/man8/statd.8*
%{_mandir}/man8/showmount.8*
%{_mandir}/man8/nfsstat.8*
%{_mandir}/man8/rpcdebug.8*
%{_mandir}/man8/mountstats.8*
%{_mandir}/man8/nfsiostat.8*
%{_mandir}/man8/nfsidmap.8*
%{_mandir}/man8/blkmapd.8*
%{_mandir}/man8/rpc.gssd.8*
%{_mandir}/man8/rpc.idmapd.8*
%{_mandir}/man8/gssd.8*
%{_mandir}/man8/idmapd.8*
%{_mandir}/man8/nfsdcltrack.8*
%{_mandir}/man8/nfsdcld.8*
%{_mandir}/man8/nfsdclddb.8*
%{_mandir}/man8/nfsdclnts.8*

%files -n %{libname}
%doc support/nfsidmap/AUTHORS support/nfsidmap/README support/nfsidmap/COPYING
%config(noreplace) %{_sysconfdir}/idmapd.conf
%{_libdir}/libnfsidmap.so.*
%{_libdir}/libnfsidmap/*.so
%{_mandir}/man3/nfs4_uid_to_name.*
%{_mandir}/man5/idmapd.conf.*

%files -n %{devname}
%{_libdir}/pkgconfig/libnfsidmap.pc
%{_includedir}/nfsidmap.h
%{_includedir}/nfsidmap_plugin.h
%{_libdir}/libnfsidmap.so



%changelog
* Wed Nov 25 2020 tv <tv> 1:2.5.2-2.mga8
+ Revision: 1649229
- BR new rpcgen pkg for bulding with glibc-2.32

* Fri Oct 23 2020 guillomovitch <guillomovitch> 1:2.5.2-1.mga8
+ Revision: 1638937
- new version 2.5.2

* Tue Jul 14 2020 guillomovitch <guillomovitch> 1:2.5.1-3.mga8
+ Revision: 1606109
- new version 2.5.1

* Tue Feb 18 2020 umeabot <umeabot> 1:2.4.3-3.mga8
+ Revision: 1538433
- Mageia 8 Mass Rebuild

* Sun Feb 16 2020 daviddavid <daviddavid> 1:2.4.3-2.mga8
+ Revision: 1532101
- rebuild for new libevent 2.1.11

* Tue Feb 11 2020 guillomovitch <guillomovitch> 1:2.4.3-1.mga8
+ Revision: 1489638
- new version 2.4.3
+ wally <wally>
- replace deprecated %%configure2_5x

* Thu Nov 21 2019 guillomovitch <guillomovitch> 1:2.4.2-2.mga8
+ Revision: 1462040
- new version 2.4.2

* Mon Jul 01 2019 guillomovitch <guillomovitch> 1:2.4.1-1.mga8
+ Revision: 1417232
- new version 2.4.1

* Sat Jun 22 2019 guillomovitch <guillomovitch> 1:2.3.4-3.mga7
+ Revision: 1400495
- sync patches with Fedora

* Thu May 23 2019 akien <akien> 1:2.3.4-2.mga7
+ Revision: 1398937
- Fix werror=format issue on i586 (patch by joeghi)
+ guillomovitch <guillomovitch>
- new version 2.3.4

* Tue May 14 2019 kekepower <kekepower> 1:2.3.3-4.mga7
+ Revision: 1397664
- Add patch to change /var/run to /run
+ tv <tv>
- fix URL + use s/bz2/xz/ tarball

* Sat Oct 27 2018 guillomovitch <guillomovitch> 1:2.3.3-3.mga7
+ Revision: 1326160
- restore setuid bit on nfs.mount (mga#23742)
- move rpc.statd from /usr/sbin to /sbin

* Thu Sep 20 2018 guillomovitch <guillomovitch> 1:2.3.3-2.mga7
+ Revision: 1288801
- turn hard dependency on quota to a soft dependency on quota-rpc
- fix systemd generators path

* Thu Sep 13 2018 guillomovitch <guillomovitch> 1:2.3.3-1.mga7
+ Revision: 1258914
- new version 2.3.3

* Wed May 30 2018 guillomovitch <guillomovitch> 1:2.3.2-1.mga7
+ Revision: 1233155
- new version 2.3.2

* Fri Dec 22 2017 guillomovitch <guillomovitch> 1:2.3.1-1.mga7
+ Revision: 1183795
- new version 2.3.1

* Thu Nov 09 2017 guillomovitch <guillomovitch> 1:2.2.1-1.mga7
+ Revision: 1176666
- new version 2.2.1

* Tue Jul 25 2017 guillomovitch <guillomovitch> 1:2.1.1-2.mga7
+ Revision: 1130384
- sync with fedora package

* Fri Jul 21 2017 guillomovitch <guillomovitch> 1:2.1.1-1.mga7
+ Revision: 1125705
- new version 2.1.1
+ ghibo <ghibo>
- Rebuilg against libtirpc

* Thu Jul 06 2017 ghibo <ghibo> 1:1.3.4-4.mga6
+ Revision: 1109105
- Bump release for rebuilding

* Thu Jul 06 2017 ghibo <ghibo> 1:1.3.4-3.mga6
+ Revision: 1109083
- Enable -fpie on building.
- Removed duplicated files from filelist.

* Thu Feb 16 2017 guillomovitch <guillomovitch> 1:1.3.4-2.mga6
+ Revision: 1086401
- fix ordering issue preventing NFS server to start at boot time (#20255)

* Sun Aug 21 2016 guillomovitch <guillomovitch> 1:1.3.4-1.mga6
+ Revision: 1047604
- version 1.3.4 (final)

* Mon Jul 11 2016 guillomovitch <guillomovitch> 1:1.3.4-0.rc5.2.mga6
+ Revision: 1041062
- fix nfs-utils_env.sh script location (fix #18897)

* Wed Jul 06 2016 guillomovitch <guillomovitch> 1:1.3.4-0.rc5.1.mga6
+ Revision: 1039173
- set version to 1.3.4, to match actual source content
  update to rc5

* Sun Mar 20 2016 guillomovitch <guillomovitch> 1:1.3.3-4.mga6
+ Revision: 993072
- sync patches with fedora

* Sat Jan 02 2016 tv <tv> 1:1.3.3-3.mga6
+ Revision: 918178
- rebuild for new libtirpc

* Tue Dec 22 2015 guillomovitch <guillomovitch> 1:1.3.3-2.mga6
+ Revision: 913575
- drop prehistoric doc files, use newer ones
- reintroduce /etc/exports file, it still works as expected (#17327)
- fix client unit name (#17357)

* Thu Dec 03 2015 guillomovitch <guillomovitch> 1:1.3.3-1.mga6
+ Revision: 907835
- new version 1.3.3
- sync with upstream systemd units (may need further update work...)

* Mon Jan 12 2015 colin <colin> 1:1.3.0-6.mga5
+ Revision: 810092
- Fix /usr/bin/start-statd for Mageia paths and unit names

* Wed Oct 15 2014 umeabot <umeabot> 1:1.3.0-5.mga5
+ Revision: 740052
- Second Mageia 5 Mass Rebuild

* Wed Oct 08 2014 luigiwalser <luigiwalser> 1:1.3.0-4.mga5
+ Revision: 737540
- UsrMove fixes

* Tue Sep 16 2014 umeabot <umeabot> 1:1.3.0-3.mga5
+ Revision: 682880
- Mageia 5 Mass Rebuild

* Mon Sep 08 2014 blino <blino> 1:1.3.0-2.mga5
+ Revision: 673661
- fix segfault when built with gcc 4.9 (from upstream git)

* Sun Jul 06 2014 guillomovitch <guillomovitch> 1:1.3.0-1.mga5
+ Revision: 645943
- new version 1.3.0

* Tue Feb 25 2014 guillomovitch <guillomovitch> 1:1.2.9-1.mga5
+ Revision: 597166
- new version 1.2.9
- install scripts under %%_libexecdir, as on fedora
- minor cosmetics systemd units changes

* Sat Oct 19 2013 umeabot <umeabot> 1:1.2.8-2.mga4
+ Revision: 523667
- Mageia 4 Mass Rebuild

* Fri May 24 2013 guillomovitch <guillomovitch> 1:1.2.8-1.mga4
+ Revision: 426098
- new version

* Mon May 06 2013 colin <colin> 1:1.2.7-3.mga3
+ Revision: 412434
- Enable nfs.target on install and handle migration from sysvinit scripts.
- idmap requires /var/lib/nfs/rpc_pipefs
- Require 'quota' for rpc.rquoatad binary.
- systemd unit tweaks:
-  * Remove [Install] rules for all units that are implicitly started by other units.
-  * Ensure all service units that are under admin control are WantedBy=nfs.target
-  * Clarify unit names (nfs.target is for both clients and servers, nfs-secure.service is for clients)
-  * Standardise sysconfig variable names (*OPTS vs. *ARG vs. *ARGS -> *ARGS)
- Fix typo in argument variable (from Fedora)
+ umeabot <umeabot>
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Nov 29 2012 guillomovitch <guillomovitch> 1:1.2.7-1.mga3
+ Revision: 323150
- new version

* Wed Nov 14 2012 blino <blino> 1:1.2.6-7.mga3
+ Revision: 317928
- add rpc module aliases, moved from kmod (from JA Magallon, mga#6918)

* Mon Oct 01 2012 colin <colin> 1:1.2.6-6.mga3
+ Revision: 301513
- Enable libmount mounting. Solves various issues relating to nofail and user mount options.

* Sat Jul 21 2012 dlucio <dlucio> 1:1.2.6-5.mga3
+ Revision: 273053
- lets provide clients to make the drakconf work properly

* Thu Jun 14 2012 blino <blino> 1:1.2.6-4.mga3
+ Revision: 260513
- move module alias nfs.conf to /etc/modprobe.d

* Wed Jun 13 2012 blino <blino> 1:1.2.6-3.mga3
+ Revision: 260392
- do not install modalias nfs.conf in a sub-directory (this is invalid)

* Mon Jun 11 2012 guillomovitch <guillomovitch> 1:1.2.6-2.mga3
+ Revision: 259882
- add exports.d directory
- use /var/lib/nfs/statd for statd, instead of /var/lib/nfs, as in fedora
- add modprobe config file to alias 'nfs4' to 'nfs'
- add systemd support
- drop sysinit support
- merge client and server package, as per redhat setup

* Thu May 31 2012 guillomovitch <guillomovitch> 1:1.2.6-1.mga3
+ Revision: 252212
- drop obsoletes upgrade posts scriptlets
- drop obsolete README.upgrade file
- drop obsolete documentation
- new version

* Fri Sep 30 2011 guillomovitch <guillomovitch> 1:1.2.5-1.mga2
+ Revision: 150508
- new version
- new version
- get rid of old conflict tags in spec file

* Tue Feb 08 2011 ennael <ennael> 1:1.2.3-2.mga1
+ Revision: 49044
- imported package nfs-utils

